using System;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;
using AddinExpress.OL;

namespace ADX_OL_Advanced_Forms_State_CS
{
	/// <summary>
	/// Summary description for ADXOlForm1.
	/// </summary>
	public class ADXOlForm1 : AddinExpress.OL.ADXOlForm
	{
		private Button buttonCheckForms;
		private TextBox textBoxDetails;
		private System.ComponentModel.IContainer components = null;

		public ADXOlForm1()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonCheckForms = new System.Windows.Forms.Button();
			this.textBoxDetails = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// buttonCheckForms
			// 
			this.buttonCheckForms.Location = new System.Drawing.Point(12, 12);
			this.buttonCheckForms.Name = "buttonCheckForms";
			this.buttonCheckForms.Size = new System.Drawing.Size(85, 23);
			this.buttonCheckForms.TabIndex = 0;
			this.buttonCheckForms.Text = "Check Forms";
			this.buttonCheckForms.UseVisualStyleBackColor = true;
			this.buttonCheckForms.Click += new System.EventHandler(this.buttonCheckForms_Click);
			// 
			// textBoxDetails
			// 
			this.textBoxDetails.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
						| System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.textBoxDetails.Location = new System.Drawing.Point(12, 41);
			this.textBoxDetails.Multiline = true;
			this.textBoxDetails.Name = "textBoxDetails";
			this.textBoxDetails.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxDetails.Size = new System.Drawing.Size(276, 147);
			this.textBoxDetails.TabIndex = 1;
			// 
			// ADXOlForm1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(300, 200);
			this.Controls.Add(this.textBoxDetails);
			this.Controls.Add(this.buttonCheckForms);
			this.Name = "ADXOlForm1";
			this.Text = "ADXOlForm1";
			this.ADXBeforeFormShow += new AddinExpress.OL.ADXOlForm.BeforeFormShow_EventHandler(this.ADXOlForm1_ADXBeforeFormShow);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		#endregion

		private bool isExplorer = false;

		private void ADXOlForm1_ADXBeforeFormShow()
		{
			if (this.Text == "ADXOlForm1")
			{
				if (this.ExplorerObj != null)
				{
					this.isExplorer = true;
					this.Text = "Explorer Form " +
						(this.Item.Collection.IndexOf(this.Item) - 1).ToString();
				}
				if (this.InspectorObj != null)
				{
					this.isExplorer = false;
					this.Text = "Inspector Form " +
						(this.Item.Collection.IndexOf(this.Item) + 1).ToString();
				}
			}
		}

		private void buttonCheckForms_Click(object sender, EventArgs e)
		{
			string text = string.Empty;
			for (int i = 0; i < this.FormsManager.Items.Count; i++)
			{
				for (int j = 0; j < this.FormsManager.Items[i].FormInstanceCount; j++)
				{
					ADXOlForm form = this.FormsManager.Items[i].FormInstances(j);
					if (form != null && form != this)
					{
						text +=
							form.Text + Environment.NewLine +
							"State: " + GetFormState(form).ToString() +
							Environment.NewLine +
							"Region: " + GetFormRegion(form).ToString() +
							Environment.NewLine +
							Environment.NewLine;
						(form as ADXOlForm1).textBoxDetails.Clear();
					}
				}
			}

			textBoxDetails.Text =
				"--- THIS FORM: ---" + Environment.NewLine +
				this.Text + Environment.NewLine +
				"State: " + GetFormState(this).ToString() + Environment.NewLine +
				"Region: " + GetFormRegion(this).ToString() + Environment.NewLine +
				"" + Environment.NewLine +
				"--- OTHER FORMS: ---" + Environment.NewLine +
				text;
		}

		public enum FormState
		{
			Focused,
			Visible,
			InRegion,
			InCache
		}

		public FormState GetFormState(ADXOlForm instance)
		{
			if (instance.Visible && instance.Active && CheckFocused(instance))
				return FormState.Focused;
			if (instance.Visible && instance.Active)
				return FormState.Visible;
			if (instance.Visible)
				return FormState.InRegion;
			return FormState.InCache;
		}

		public object GetFormRegion(ADXOlForm instance)
		{
			if ((instance as ADXOlForm1).isExplorer)
				return instance.Item.ExplorerLayout;
			return instance.Item.InspectorLayout;
		}

		public bool CheckFocused(ADXOlForm instance)
		{
			for (int i = 0; i < instance.Controls.Count; i++)
				if (instance.Controls[i].Focused)
					return true;
			return false;
		}
	}
}
